/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : ErrorTable.java                                          */
/* DESCRIPTION   : Table of error reports                                   */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 28th August 2003                                         */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 27th October 2003                                        */
/****************************************************************************/

package bfl.error;

import java.util.*;
import java.io.*;

public class ErrorTable {

    private Vector errors;

    public ErrorTable() {
	errors = new Vector();
    }

    // Adds a new error.

    public void add(int line, Error e) {
	errors.addElement(new ErrorTableEntry(line,e));
    }

    public boolean hasErrors() {
	return !(errors.isEmpty());
    }

    public void output(PrintStream out, String header) {
	int numErrors = errors.size();
	out.print(numErrors);
	out.println(" errors were found " + header + ":");
	out.println();
	Enumeration errs = errors.elements();
	while (errs.hasMoreElements()) {
	    ((ErrorTableEntry)errs.nextElement()).output(out);
	    out.println();
	}
    }

}
