/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : IfMismatchError.java                                     */
/* DESCRIPTION   : Error: conditional branches have unequal types           */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 28th August 2003                                         */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 28th August 2003                                         */
/****************************************************************************/

package bfl.error;

public class IfMismatchError extends Error {

    public String thenType;
    public String elseType;

    public IfMismatchError(String t, String u) {
	thenType = t;
	elseType = u;
    }

    public String message() {
	return "the branches of \"if-then-else\" should have the same type " +
	    "but here the \"then\" branch has type \"" + thenType + "\" " +
	    "and the \"else\" branch has type \"" + elseType + "\""; 
    } 

}
