/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : WrongArgTypeError.java                                   */
/* DESCRIPTION   : Error: wrong type of argument to function                */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 17th September 2003                                      */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 27th October 2003                                        */
/****************************************************************************/

package bfl.error;

public class WrongArgTypeError extends Error {

    public String formal;
    public String actual;

    public WrongArgTypeError(String f, String a) {
	formal = f;
	actual = a;
    }

    public String message() {
	return "function expects argument type " + formal +
	    " but type " + actual +
	    " has been supplied";
    } 

}
