/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : WrongResultTypeError.java                                */
/* DESCRIPTION   : Error: type of function body does not match declared     */
/*                 result type                                              */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 18th September 2003                                      */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 18th September 2003                                      */
/****************************************************************************/

package bfl.error;

public class WrongResultTypeError extends Error {

    public String id;
    public String rType;
    public String bType;

    public WrongResultTypeError(String i, String r, String b) {
	id = i;
	rType = r;
	bType = b;
    }

    public String message() {
	return "the declared result type of function \"" + id + 
	    "\" is \"" + rType + "\" but the type of its body is \"" +
	    bType + "\"";
    } 

}
