/* This file was generated by SableCC (http://www.sablecc.org/). */

package bfl.lexer;

import java.io.*;
import java.util.*;
import bfl.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TInt(text, line, pos); }
    Token new3(int line, int pos) { return new TPlus(line, pos); }
    Token new4(int line, int pos) { return new TAnd(line, pos); }
    Token new5(int line, int pos) { return new TEq(line, pos); }
    Token new6(int line, int pos) { return new TIf(line, pos); }
    Token new7(int line, int pos) { return new TThen(line, pos); }
    Token new8(int line, int pos) { return new TElse(line, pos); }
    Token new9(int line, int pos) { return new TIs(line, pos); }
    Token new10(int line, int pos) { return new TTrue(line, pos); }
    Token new11(int line, int pos) { return new TFalse(line, pos); }
    Token new12(int line, int pos) { return new TFn(line, pos); }
    Token new13(int line, int pos) { return new TArrow(line, pos); }
    Token new14(int line, int pos) { return new TFun(line, pos); }
    Token new15(int line, int pos) { return new TVal(line, pos); }
    Token new16(int line, int pos) { return new TLet(line, pos); }
    Token new17(int line, int pos) { return new TIn(line, pos); }
    Token new18(int line, int pos) { return new TEnd(line, pos); }
    Token new19(int line, int pos) { return new TIntTy(line, pos); }
    Token new20(int line, int pos) { return new TBoolTy(line, pos); }
    Token new21(int line, int pos) { return new TFunArrow(line, pos); }
    Token new22(int line, int pos) { return new TLparen(line, pos); }
    Token new23(int line, int pos) { return new TRparen(line, pos); }
    Token new24(int line, int pos) { return new TComma(line, pos); }
    Token new25(int line, int pos) { return new TColon(line, pos); }
    Token new26(int line, int pos) { return new TSemi(line, pos); }
    Token new27(String text, int line, int pos) { return new TId(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {38, 38, 5}, {40, 40, 6}, {41, 41, 7}, {43, 43, 8}, {44, 44, 9}, {45, 45, 10}, {47, 47, 11}, {48, 57, 12}, {58, 58, 13}, {59, 59, 14}, {61, 61, 15}, {65, 90, 16}, {97, 97, 16}, {98, 98, 17}, {99, 100, 16}, {101, 101, 18}, {102, 102, 19}, {103, 104, 16}, {105, 105, 20}, {106, 107, 16}, {108, 108, 21}, {109, 115, 16}, {116, 116, 22}, {117, 117, 16}, {118, 118, 23}, {119, 122, 16}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 24}, },
            {{47, 47, 25}, },
            {{48, 57, 26}, },
            {},
            {},
            {{61, 61, 27}, {62, 62, 28}, },
            {{65, 90, 29}, {97, 122, 29}, },
            {{65, 90, 29}, {97, 110, 29}, {111, 111, 30}, {112, 122, 29}, },
            {{65, 90, 29}, {97, 107, 29}, {108, 108, 31}, {109, 109, 29}, {110, 110, 32}, {111, 122, 29}, },
            {{65, 90, 29}, {97, 97, 33}, {98, 109, 29}, {110, 110, 34}, {111, 116, 29}, {117, 117, 35}, {118, 122, 29}, },
            {{65, 90, 29}, {97, 101, 29}, {102, 102, 36}, {103, 109, 29}, {110, 110, 37}, {111, 122, 29}, },
            {{65, 90, 29}, {97, 100, 29}, {101, 101, 38}, {102, 122, 29}, },
            {{65, 90, 29}, {97, 103, 29}, {104, 104, 39}, {105, 113, 29}, {114, 114, 40}, {115, 122, 29}, },
            {{65, 90, 29}, {97, 97, 41}, {98, 122, 29}, },
            {},
            {{9, 9, 42}, {10, 10, 43}, {13, 13, 44}, {32, 127, 42}, },
            {{48, 57, 26}, },
            {},
            {},
            {{65, 122, -18}, },
            {{65, 110, -19}, {111, 111, 45}, {112, 122, 29}, },
            {{65, 90, 29}, {97, 114, 29}, {115, 115, 46}, {116, 122, 29}, },
            {{65, 90, 29}, {97, 99, 29}, {100, 100, 47}, {101, 122, 29}, },
            {{65, 107, -20}, {108, 108, 48}, {109, 122, 29}, },
            {{65, 122, -18}, },
            {{65, 90, 29}, {97, 109, 29}, {110, 110, 49}, {111, 122, 29}, },
            {{65, 122, -18}, },
            {{65, 90, 29}, {97, 115, 29}, {116, 116, 50}, {117, 122, 29}, },
            {{65, 115, -39}, {116, 116, 51}, {117, 122, 29}, },
            {{65, 100, -23}, {101, 101, 52}, {102, 122, 29}, },
            {{65, 90, 29}, {97, 116, 29}, {117, 117, 53}, {118, 122, 29}, },
            {{65, 107, -20}, {108, 108, 54}, {109, 122, 29}, },
            {{9, 127, -27}, },
            {},
            {},
            {{65, 107, -20}, {108, 108, 55}, {109, 122, 29}, },
            {{65, 100, -23}, {101, 101, 56}, {102, 122, 29}, },
            {{65, 122, -18}, },
            {{65, 114, -33}, {115, 115, 57}, {116, 122, 29}, },
            {{65, 122, -18}, },
            {{65, 122, -18}, },
            {{65, 122, -18}, },
            {{65, 109, -37}, {110, 110, 58}, {111, 122, 29}, },
            {{65, 100, -23}, {101, 101, 59}, {102, 122, 29}, },
            {{65, 122, -18}, },
            {{65, 122, -18}, },
            {{65, 122, -18}, },
            {{65, 100, -23}, {101, 101, 60}, {102, 122, 29}, },
            {{65, 122, -18}, },
            {{65, 122, -18}, },
            {{65, 122, -18}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {0, 0, 0, 0, 0, 4, 22, 23, 3, 24, -1, -1, 2, 25, 26, 9, 27, 27, 27, 27, 27, 27, 27, 27, 21, -1, 2, 5, 13, 27, 27, 27, 27, 27, 12, 27, 6, 17, 27, 27, 27, 27, -1, 1, 1, 27, 27, 18, 27, 14, 19, 16, 27, 27, 15, 20, 8, 27, 7, 10, 11, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
