/* This file was generated by SableCC (http://www.sablecc.org/). */

package bfl.parser;

import bfl.lexer.*;
import bfl.node.*;
import bfl.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(0), node, true); } break;
                    case 3: { Node node = new3(); push(goTo(0), node, true); } break;
                    case 4: { Node node = new4(); push(goTo(0), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(0), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(0), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(0), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(0), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(7), node, false); } break;
                    case 10: { Node node = new10(); push(goTo(7), node, false); } break;
                    case 11: { Node node = new11(); push(goTo(1), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(1), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(1), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(1), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(2), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(2), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(3), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(3), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(4), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(4), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(5), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(5), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(5), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(6), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PExpression node1 = (PExpression) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PTerm node1 = (PTerm) pop();
        ATermExpression node = new ATermExpression(node1);
        return node;
    }

    Node new1()
    {
        PTerm node3 = (PTerm) pop();
        TPlus node2 = (TPlus) pop();
        PTerm node1 = (PTerm) pop();
        APlusExpression node = new APlusExpression(node1, node2, node3);
        return node;
    }

    Node new2()
    {
        PTerm node3 = (PTerm) pop();
        TAnd node2 = (TAnd) pop();
        PTerm node1 = (PTerm) pop();
        AAndExpression node = new AAndExpression(node1, node2, node3);
        return node;
    }

    Node new3()
    {
        PTerm node3 = (PTerm) pop();
        TEq node2 = (TEq) pop();
        PTerm node1 = (PTerm) pop();
        AEqExpression node = new AEqExpression(node1, node2, node3);
        return node;
    }

    Node new4()
    {
        PExpression node6 = (PExpression) pop();
        TElse node5 = (TElse) pop();
        PExpression node4 = (PExpression) pop();
        TThen node3 = (TThen) pop();
        PExpression node2 = (PExpression) pop();
        TIf node1 = (TIf) pop();
        ACondExpression node = new ACondExpression(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new5()
    {
        PExpression node4 = (PExpression) pop();
        TArrow node3 = (TArrow) pop();
        PTypedArg node2 = (PTypedArg) pop();
        TFn node1 = (TFn) pop();
        AFnExpression node = new AFnExpression(node1, node2, node3, node4);
        return node;
    }

    Node new6()
    {
        PTerm node2 = (PTerm) pop();
        PTerm node1 = (PTerm) pop();
        AAppExpression node = new AAppExpression(node1, node2);
        return node;
    }

    Node new7()
    {
        TEnd node5 = (TEnd) pop();
        PExpression node4 = (PExpression) pop();
        TIn node3 = (TIn) pop();
        XPBinding node2 = null;
        TLet node1 = (TLet) pop();
        ALetExpression node = new ALetExpression(node1, node2, node3, node4, node5);
        return node;
    }

    Node new8()
    {
        TEnd node5 = (TEnd) pop();
        PExpression node4 = (PExpression) pop();
        TIn node3 = (TIn) pop();
        XPBinding node2 = (XPBinding) pop();
        TLet node1 = (TLet) pop();
        ALetExpression node = new ALetExpression(node1, node2, node3, node4, node5);
        return node;
    }

    Node new9()
    {
        PBinding node2 = (PBinding) pop();
        XPBinding node1 = (XPBinding) pop();
        X1PBinding node = new X1PBinding(node1, node2);
        return node;
    }

    Node new10()
    {
        PBinding node1 = (PBinding) pop();
        X2PBinding node = new X2PBinding(node1);
        return node;
    }

    Node new11()
    {
        TInt node1 = (TInt) pop();
        AIntLitTerm node = new AIntLitTerm(node1);
        return node;
    }

    Node new12()
    {
        PBool node1 = (PBool) pop();
        ABoolLitTerm node = new ABoolLitTerm(node1);
        return node;
    }

    Node new13()
    {
        TId node1 = (TId) pop();
        AIdTerm node = new AIdTerm(node1);
        return node;
    }

    Node new14()
    {
        TRparen node3 = (TRparen) pop();
        PExpression node2 = (PExpression) pop();
        TLparen node1 = (TLparen) pop();
        AExpTerm node = new AExpTerm(node1, node2, node3);
        return node;
    }

    Node new15()
    {
        PExpression node4 = (PExpression) pop();
        TIs node3 = (TIs) pop();
        TId node2 = (TId) pop();
        TVal node1 = (TVal) pop();
        AValBinding node = new AValBinding(node1, node2, node3, node4);
        return node;
    }

    Node new16()
    {
        PExpression node9 = (PExpression) pop();
        TIs node8 = (TIs) pop();
        PTy node7 = (PTy) pop();
        TColon node6 = (TColon) pop();
        TRparen node5 = (TRparen) pop();
        PTypedArg node4 = (PTypedArg) pop();
        TLparen node3 = (TLparen) pop();
        TId node2 = (TId) pop();
        TFun node1 = (TFun) pop();
        AFunBinding node = new AFunBinding(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new17()
    {
        TTrue node1 = (TTrue) pop();
        ATrueBool node = new ATrueBool(node1);
        return node;
    }

    Node new18()
    {
        TFalse node1 = (TFalse) pop();
        AFalseBool node = new AFalseBool(node1);
        return node;
    }

    Node new19()
    {
        PBaseTy node1 = (PBaseTy) pop();
        ABaseTy node = new ABaseTy(node1);
        return node;
    }

    Node new20()
    {
        PBaseTy node3 = (PBaseTy) pop();
        TFunArrow node2 = (TFunArrow) pop();
        PBaseTy node1 = (PBaseTy) pop();
        AFunTy node = new AFunTy(node1, node2, node3);
        return node;
    }

    Node new21()
    {
        TIntTy node1 = (TIntTy) pop();
        AIntBaseTy node = new AIntBaseTy(node1);
        return node;
    }

    Node new22()
    {
        TBoolTy node1 = (TBoolTy) pop();
        ABoolBaseTy node = new ABoolBaseTy(node1);
        return node;
    }

    Node new23()
    {
        TRparen node3 = (TRparen) pop();
        PTy node2 = (PTy) pop();
        TLparen node1 = (TLparen) pop();
        ACompoundBaseTy node = new ACompoundBaseTy(node1, node2, node3);
        return node;
    }

    Node new24()
    {
        PTy node3 = (PTy) pop();
        TColon node2 = (TColon) pop();
        TId node1 = (TId) pop();
        ATypedArg node = new ATypedArg(node1, node2, node3);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 2}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 5}, {25, SHIFT, 13}, },
			{{-1, ERROR, 6}, {12, SHIFT, 15}, {13, SHIFT, 16}, {15, SHIFT, 17}, },
			{{-1, ERROR, 7}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 9}, {26, ACCEPT, -1}, },
			{{-1, REDUCE, 0}, {0, SHIFT, 1}, {1, SHIFT, 21}, {2, SHIFT, 22}, {3, SHIFT, 23}, {8, SHIFT, 3}, {9, SHIFT, 4}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 12}, {5, SHIFT, 25}, },
			{{-1, ERROR, 13}, {23, SHIFT, 26}, },
			{{-1, ERROR, 14}, {11, SHIFT, 27}, },
			{{-1, ERROR, 15}, {25, SHIFT, 28}, },
			{{-1, ERROR, 16}, {25, SHIFT, 29}, },
			{{-1, ERROR, 17}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 19}, {12, SHIFT, 15}, {13, SHIFT, 16}, {15, SHIFT, 31}, },
			{{-1, ERROR, 20}, {21, SHIFT, 33}, },
			{{-1, ERROR, 21}, {0, SHIFT, 1}, {8, SHIFT, 3}, {9, SHIFT, 4}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, ERROR, 22}, {0, SHIFT, 1}, {8, SHIFT, 3}, {9, SHIFT, 4}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, ERROR, 23}, {0, SHIFT, 1}, {8, SHIFT, 3}, {9, SHIFT, 4}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 25}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, ERROR, 26}, {17, SHIFT, 38}, {18, SHIFT, 39}, {20, SHIFT, 40}, },
			{{-1, ERROR, 27}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, ERROR, 28}, {20, SHIFT, 44}, },
			{{-1, ERROR, 29}, {7, SHIFT, 45}, },
			{{-1, ERROR, 30}, {16, SHIFT, 46}, },
			{{-1, ERROR, 31}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 37}, {6, SHIFT, 48}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 40}, {17, SHIFT, 38}, {18, SHIFT, 39}, {20, SHIFT, 40}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 19}, {19, SHIFT, 50}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 44}, {25, SHIFT, 13}, },
			{{-1, ERROR, 45}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 47}, {16, SHIFT, 53}, },
			{{-1, ERROR, 48}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, ERROR, 49}, {21, SHIFT, 55}, },
			{{-1, ERROR, 50}, {17, SHIFT, 38}, {18, SHIFT, 39}, {20, SHIFT, 40}, },
			{{-1, ERROR, 51}, {21, SHIFT, 57}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 8}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 57}, {23, SHIFT, 58}, },
			{{-1, ERROR, 58}, {17, SHIFT, 38}, {18, SHIFT, 39}, {20, SHIFT, 40}, },
			{{-1, ERROR, 59}, {7, SHIFT, 60}, },
			{{-1, ERROR, 60}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {10, SHIFT, 5}, {14, SHIFT, 6}, {20, SHIFT, 7}, {25, SHIFT, 8}, },
			{{-1, REDUCE, 16}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 9}, {2, 12}, {7, 20}, {17, 30}, {25, 37}, {27, 43}, {31, 47}, {45, 52}, {48, 54}, {60, 61}, },
			{{-1, 10}, {10, 24}, {21, 34}, {22, 35}, {23, 36}, },
			{{-1, 18}, {19, 32}, },
			{{-1, 11}, },
			{{-1, 41}, {40, 49}, {58, 59}, },
			{{-1, 42}, {50, 56}, },
			{{-1, 14}, {44, 51}, },
			{{-1, 19}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: int, 'if', 'true', 'false', 'fn', 'let', '(', id",
			"expecting: int, '+', '&', '==', 'then', 'else', 'true', 'false', 'fun', 'val', 'in', 'end', '(', ')', id, EOF",
			"expecting: id",
			"expecting: 'fun', 'val', 'in'",
			"expecting: EOF",
			"expecting: 'then'",
			"expecting: ':'",
			"expecting: '=>'",
			"expecting: ')'",
			"expecting: int, 'true', 'false', '(', id",
			"expecting: 'then', 'else', 'fun', 'val', 'in', 'end', ')', EOF",
			"expecting: 'int', 'bool', '('",
			"expecting: '('",
			"expecting: '='",
			"expecting: 'end'",
			"expecting: 'else'",
			"expecting: '=', '=>', '->', ')'",
			"expecting: '=>', ')'",
			"expecting: '=', '=>', ')'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 0, 1, 1, 2, 3, 0, 1, 4, 1, 1, 5, 6, 7, 2, 2, 0, 3, 3, 8, 9, 9, 9, 10, 0, 11, 0, 12, 13, 14, 0, 3, 1, 10, 10, 10, 15, 16, 16, 11, 17, 16, 10, 2, 0, 10, 14, 0, 8, 11, 8, 3, 10, 10, 16, 18, 6, 11, 13, 0, 3, 
        };*/
}
