/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : FunType.java                                             */
/* DESCRIPTION   : Representation of function type                          */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 27th October 2003                                         */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 27th October 2003                                      */
/****************************************************************************/

package bfl.types;

public class FunType extends Type {
    public Type arg;
    public Type res;

    public FunType(Type a, Type r) {
	arg = a;
	res = r;
    }

    public Type getArg() {
	return arg;
    }

    public Type getRes() {
	return res;
    }

    public String name() {
	String n = "";
	if (arg instanceof FunType) {
	    n = n + "(" + arg.name() + ")";
	}
	else {
	    n = n + arg.name();
	};
	n = n + "->";
	if (res instanceof FunType) {
	    n = n + "(" + res.name() + ")";
	}
	else {
	    n = n + res.name();
	};
	return n;
    }

    public boolean equal(Type t) {
	return ((t instanceof FunType)
		&& arg.equal(((FunType)t).getArg())
		&& res.equal(((FunType)t).getRes()));
    }

}
